window.onload = function() {
  
  // the DICOM files
  //
  // this is a brain MR with dimensions 26x256x148 vx
  // some slices were removed to get the 'look-into-the-brain' effect

  // create a new test_renderer
  
  
  //const newconfig = {PROGRESSBAR_ENABLED: false, PICKING_ENABLED: true, ORDERING_ENABLED: true, STATISTICS_ENABLED: false, INTERMEDIATE_RENDERING: false};
  var r = new X.renderer3D();
  //r.config.PROGRESSBAR_ENABLED = false;

  var cloud = 'perseus';
  r.container = 'r1';
  r.init();
  r.camera.up = [0,0,1];
  r.camera.position=[0,0,100];
  
  
  const varr= [0.6422067880630493, -0.598655104637146, 0.478728711605072, 0, 0.7290990948677063, 0.28428563475608826, -0.6225726008415222, 0, 0.2366108000278473, 0.7488608360290527, 0.6190497279167175, 0, 0, -0.9999499917030334, -79.9949951171875, 1];
  vpos = new Float32Array(16);
  for (var k = 0; k < varr.length; k++) {
    vpos[k]=varr[k]
    }
  r.camera.view = vpos;

  // we create the X.volume container and attach all DICOM files
  var v1 = new X.volume();
  // map the data url to each of the slices
  v1.file = cloud + '.nii';
  
  var v2 = new X.volume();
  v2.file = cloud + '.nii';
  
  // add the volume
  r.add(v1);
  r.add(v2);
    
  var inner_mesh = new X.mesh();
  inner_mesh.file=cloud + '_inner_0.stl';
  r.add(inner_mesh);
  inner_mesh.opacity=0.75;
  inner_mesh.color= [1,1,1];
  inner_mesh.visible = false;

  
  var outer_mesh = new X.mesh();
  outer_mesh.file=cloud + '_outer_0.stl';
  r.add(outer_mesh);
  outer_mesh.opacity=0.5;
  outer_mesh.color= [0.6,0.96,0.96];
  outer_mesh.visible = false;
       
  
  r.interactor.onMouseDown = function() {

    console.log(r.camera.view) // prints the view matrix as a string
    console.log(r.config) // prints the view matrix as a string
    
  };
  
  var gui = new dat.GUI();
  

  var trackguiinner = gui.addFolder('Inner Width Topology');
  trackVisibleControllerinner = trackguiinner.add(inner_mesh, 'visible');
  trackguiinner.open();

  var trackguiouter = gui.addFolder('Outer Width Topology');
  trackVisibleControllerouter = trackguiouter.add(outer_mesh, 'visible');
  trackguiouter.open();
  
  
    r.onShowtime = function() {
    
    
    trackVisibleControllerinner.onChange(function(value) {


    if (!value) {
    Bokeh.documents[0].get_model_by_name('innerglyph').line_alpha = 0;
    Bokeh.documents[0].get_model_by_name('innerglyph').change.emit();       
        
    }
      
    if (value) {
    Bokeh.documents[0].get_model_by_name('innerglyph').line_alpha = 1;
    Bokeh.documents[0].get_model_by_name('innerglyph').change.emit();       
        
    }


    });
    
    
    // outer callbacks
    trackVisibleControllerouter.onChange(function(value) {


    if (!value) {
    Bokeh.documents[0].get_model_by_name('outerglyph').line_alpha = 0;
    Bokeh.documents[0].get_model_by_name('outerglyph').change.emit();       
        
    }
      
    if (value) {
    Bokeh.documents[0].get_model_by_name('outerglyph').line_alpha = 1;
    Bokeh.documents[0].get_model_by_name('outerglyph').change.emit();       
        
    }


    });
    
        
    // activate volume rendering
    v1.volumeRendering = true;
    v1.lowerThreshold = 4;
    v1.windowLower = 115;
    v1.windowHigh = 360;
    v1.minColor = [0.6,0.96,0.96];
    v1.maxColor = [0.6,0.96,0.96];
    v1.opacity = 0.05;
    
    // activate volume rendering
    v2.volumeRendering = true;
    v2.lowerThreshold = 35;
    v2.windowLower = 115;
    v2.windowHigh = 360;
    v2.minColor = [1,1,1];
    v2.maxColor = [1,1,1];
    v2.opacity = 0.15;
    
    
    //create spine
    for (var i = 0; i < spine_data.length; i++) {
    
    // a new cube
      var c = new X.sphere();
      // set the center position in world space
      c.center = [spine_data[i].x,spine_data[i].y,spine_data[i].z];
      c.radius=1;

      c.color = [spine_data[i].r, spine_data[i].g,spine_data[i].b];
      
      c.opacity = 1;
      
      // add it
      r.add(c);
      
      }

    for (var i = 0; i < spine_data_remaining.length; i++) {
    
      var c = new X.sphere();
      // set the center position in world space

      c.center = [spine_data_remaining[i].x,spine_data_remaining[i].y,spine_data_remaining[i].z];
      c.radius=1.;

      c.color = [spine_data_remaining[i].r, spine_data_remaining[i].g,spine_data_remaining[i].b];
      
      c.opacity = 0.25;
      
      // add it
      r.add(c);
      
    }
    
    
  };
  
        // hide waiting screen after first render!
  r.onRender = function(){

    var loadingDiv = document.getElementById('loading');
    loadingDiv.style.display = 'none';    
    
  }
  
  var button = document.getElementById('sunbutton');
  button.addEventListener ("click", function() 
  {
  r.camera.up = [0,0,1];
  r.camera.position=[0,-50,100];
  
  const varr= [0.6422067880630493, -0.598655104637146, 0.478728711605072, 0, 0.7290990948677063, 0.28428563475608826, -0.6225726008415222, 0, 0.2366108000278473, 0.7488608360290527, 0.6190497279167175, 0, 0, -0.9999499917030334, -79.9949951171875, 1];
  vpos = new Float32Array(16);
  for (var k = 0; k < varr.length; k++) {
    vpos[k]=varr[k]
    }

  r.camera.view = vpos;
  r.render();

  });
  

  
  r.render();
  


  
};
