

window.onload = function() {
  
  // the DICOM files
  //
  // this is a brain MR with dimensions 26x256x148 vx
  // some slices were removed to get the 'look-into-the-brain' effect

  // create a new test_renderer
  
  //const newconfig = {PROGRESSBAR_ENABLED: false, PICKING_ENABLED: true, ORDERING_ENABLED: true, STATISTICS_ENABLED: false, INTERMEDIATE_RENDERING: false};
  var r = new X.renderer3D();
  //r.config.PROGRESSBAR_ENABLED = false;

  var cloud = 'taurus';
  r.container = 'r1';
  r.init();
  r.camera.up = [0,0,1];
  r.camera.position=[0,-50,100];
  
  
  const varr= [0.0829065665602684, -0.329657644033432, 0.940451443195343, 0, 0.9859771728515625, -0.11001709848642349, -0.12548427283763885, 0, 0.14483396708965302, 0.9376673698425293, 0.3159140646457672, 0, 0, -0.9999499917030334, -59.9949951171875, 1];
  vpos = new Float32Array(16);
  for (var k = 0; k < varr.length; k++) {
    vpos[k]=varr[k]
    }
  r.camera.view = vpos;

  // we create the X.volume container and attach all DICOM files
  var v1 = new X.volume();
  // map the data url to each of the slices
  v1.file = cloud + '.nii';
  
  var v2 = new X.volume();
  v2.file = cloud + '.nii';
  
  // add the volume
  r.add(v1);
  r.add(v2);
    
  var inner_obj = new X.object();
  var inner_mesh_0 = new X.mesh();
  
  inner_mesh_0.file=cloud + '_inner_0.stl';
  inner_mesh_0.opacity=0.75;
  inner_mesh_0.color= [1,1,1];
  inner_mesh_0.modified();
  inner_obj.children.push(inner_mesh_0);

  var inner_mesh_1 = new X.mesh();
  inner_mesh_1.file=cloud + '_inner_1.stl';
  inner_mesh_1.opacity=0.75;
  inner_mesh_1.color= [1,1,1];
  inner_mesh_1.modified();
  inner_obj.children.push(inner_mesh_1);

  var inner_mesh_2 = new X.mesh();
  inner_mesh_2.file=cloud + '_inner_2.stl';
  inner_mesh_2.opacity=0.75;
  inner_mesh_2.color= [1,1,1];
  inner_mesh_2.modified();
  inner_obj.children.push(inner_mesh_2);

  inner_obj.visible=false;
  r.add(inner_obj);

  var outer_obj = new X.object();
  var outer_mesh_0 = new X.mesh();
  
  outer_mesh_0.file=cloud + '_outer_0.stl';
  outer_mesh_0.opacity=0.75;
  outer_mesh_0.color= [0.6,0.96,0.96];
  outer_mesh_0.modified();
  outer_obj.children.push(outer_mesh_0);

  var outer_mesh_1 = new X.mesh();
  outer_mesh_1.file=cloud + '_outer_1.stl';
  outer_mesh_1.opacity=0.75;
  outer_mesh_1.color= [0.6,0.96,0.96];
  outer_mesh_1.modified();
  outer_obj.children.push(outer_mesh_1);

  var outer_mesh_2 = new X.mesh();
  outer_mesh_2.file=cloud + '_outer_2.stl';
  outer_mesh_2.opacity=0.75;
  outer_mesh_2.color= [0.6,0.96,0.96];
  outer_mesh_2.modified();
  outer_obj.children.push(outer_mesh_2);
  outer_obj.visible=false;
  r.add(outer_obj);
  
  r.interactor.onMouseDown = function() {

    console.log(r.camera.view) // prints the view matrix as a string
    console.log(r.config) // prints the view matrix as a string
    
  };
  
  var gui = new dat.GUI();
  
  var trackgui = gui.addFolder('Low Density Volume Rendering');
  trackVisibleController = trackgui.add(v1, 'visible');
  trackgui.open();
  
  var trackgui = gui.addFolder('High Density Volume Rendering');
  trackVisibleController = trackgui.add(v2, 'visible');
  trackgui.open();
  
  var trackgui = gui.addFolder('Inner Width Topology');
  trackVisibleController = trackgui.add(inner_obj, 'visible');
  trackgui.open();

  var trackgui = gui.addFolder('Outer Width Topology');
  trackVisibleController = trackgui.add(outer_obj, 'visible');
  trackgui.open();
  
  
    r.onShowtime = function() {
    
    // activate volume rendering
    v1.volumeRendering = true;
    v1.lowerThreshold = 5;
    v1.windowLower = 115;
    v1.windowHigh = 360;
    v1.minColor = [0.6,0.96,0.96];
    v1.maxColor = [0.6,0.96,0.96];
    v1.opacity = 0.05;
    
    // activate volume rendering
    v2.volumeRendering = true;
    v2.lowerThreshold = 35;
    v2.windowLower = 115;
    v2.windowHigh = 360;
    v2.minColor = [1,1,1];
    v2.maxColor = [1,1,1];
    v2.opacity = 0.15;
    
    
    //create spine
    for (var i = 0; i < spine_data.length; i++) {
    
    // a new cube
      var c = new X.sphere();
      // set the center position in world space
      c.center = [spine_data[i].x,spine_data[i].y,spine_data[i].z];
      c.radius=1;

      c.color = [spine_data[i].r, spine_data[i].g,spine_data[i].b];
      
      c.opacity = 1;
      
      // add it
      r.add(c);
      
    }
    

    for (var i = 0; i < spine_data_remaining.length; i++) {
    
      var c = new X.sphere();
      // set the center position in world space

      c.center = [spine_data_remaining[i].x,spine_data_remaining[i].y,spine_data_remaining[i].z];
      c.radius=1.;

      c.color = [spine_data_remaining[i].r, spine_data_remaining[i].g,spine_data_remaining[i].b];
      
      c.opacity = 0.25;
      
      // add it
      r.add(c);
      
    }  

   
  };
  
      // hide waiting screen after first render!
  r.onRender = function(){

    var loadingDiv = document.getElementById('loading');
    loadingDiv.style.display = 'none';
    
    
    
    
  }
  
  var button = document.getElementById('sunbutton');
  button.addEventListener ("click", function() 
  {
  r.camera.up = [0,0,1];
  r.camera.position=[0,-50,100];
  
  const varr= [0.0829065665602684, -0.329657644033432, 0.940451443195343, 0, 0.9859771728515625, -0.11001709848642349, -0.12548427283763885, 0, 0.14483396708965302, 0.9376673698425293, 0.3159140646457672, 0, 0, -0.9999499917030334, -59.9949951171875, 1];
  vpos = new Float32Array(16);
  for (var k = 0; k < varr.length; k++) {
    vpos[k]=varr[k]
    }
  r.camera.view = vpos;
  r.render();

  });
  
 
  
  var mbutton = document.getElementById('mergebutton');
  mbutton.addEventListener ("click", function() 
  {
  window.alert("To view these data in the Merge Cube, go to https://edu.cospaces.io/JEY-GAD");
  });

    
  r.render();

  
};
